//<Script type="text/javascript">

Gtk = imports.gi.Gtk;
Gio = imports.gi.Gio;
Gdk = imports.gi.Gdk;

imports['Array.js']; 
JSDOC   = imports['JSDOC.js'].JSDOC; 
console = imports['console.js'].console; 
Roo     = imports['Roo.js'].Roo; 

Introspect = imports['JSDOC/Introspect.js'].Introspect; 

   

//var outputdir = '/home2/www/devel/seed';
var outputdir = '/var/www/seed';

// list namespace..
//var ns_list = [ 'GIRepository' ];

var ns_list = JSDOC.Introspect.namespaces().sort();
//console.dump(ns_list);
 // ns_list = [ 'Gio' ];
//ns_list = [ 'Gtk' ];
 /* 'Gdk',
    'Gtk',  
    'GLib',
    'Gio',
    'GObject',
    'GIRepository',
    'Gst',
    'Pango']
*/
var cls_list = [];

var cls_template = new JSDOC.Template(__script_path__ + '/docs/class.html');
var cls_ix_template = new JSDOC.Template(__script_path__ + '/docs/class_ix.tmpl');
var reference_template = new JSDOC.Template(__script_path__ + '/docs/references.html');

Roo.each(ns_list, function(ns_name) {
    var core;
    //if (ns_name == 'Epiphany') {
     //   return;
    //} 
    if (ns_name == 'GnomeGamesSupport') { // on gnome dev cd stuff.
        return;
    }
    
    //try {
        core = imports.gi[ns_name];
    //} catch (e) {
    //    Seed.print("SKIP (no import): "+ ns_name + ": " +  e);
        
    //    return;
    //}
    Seed.print("START:" + ns_name);
    // ones that cause problems.
    
    
    
    // Namespace file..
    var ns = Introspect.ns(ns_name);

    Gio.simple_write(outputdir + '/'+ ns_name +  '.shtml', cls_template.process(ns));
    cls_list.push({
        alias : ns_name 
    });
    
    // left bar index of elements in namespace...
    Gio.simple_write(outputdir + '/_ix_'+ ns_name +  '.shtml', cls_ix_template.process(ns));
     
    // index...
    
    
    Roo.each(ns.objects, function(n) {
        
        
        Gio.simple_write(outputdir + '/'+ ns_name + '.' + n + '.shtml', 
            cls_template.process( Introspect.factory('Class', ns_name, n)));
 
        Seed.print(ns_name + '.' +n);
    });
     Roo.each(ns.interfaces, function(n) {
        
        
        Gio.simple_write(outputdir + '/'+ ns_name + '.' + n + '.shtml', 
            cls_template.process( Introspect.factory('Interface', ns_name, n)));
 
        Seed.print(ns_name + '.' +n);
    });
    Roo.each(ns.structs, function(n) {
        
        
        Gio.simple_write(outputdir + '/'+ ns_name + '.' + n + '.shtml', 
            cls_template.process( Introspect.factory('Struct', ns_name, n)));
        
        
        Seed.print(ns_name + '.' +n);
    });
    
    Roo.each(ns.unions, function(n) {
        
        
        Gio.simple_write(outputdir + '/'+ ns_name + '.' + n + '.shtml', 
            cls_template.process( Introspect.factory('Union', ns_name, n)));
        
        
        Seed.print(ns_name + '.' +n);
    });
    
    Roo.each(ns.enums, function(n) {
        
        
        Gio.simple_write(outputdir + '/'+ ns_name + '.' + n + '.shtml', 
            cls_template.process( Introspect.factory('Enum', ns_name, n)));
        
        
        Seed.print(ns_name + '.' +n);
    });
    
})

for (var i in Introspect.references) {
    
    console.log("REFERENCE: " + i + ' : ' + Introspect.references[i].length);
    Gio.simple_write(outputdir + '/references.'+ i + '.html', 
            reference_template.process( Introspect.references[i] ));
       
}

var ix_template = new JSDOC.Template(__script_path__ + '/docs/index.tmpl');
Gio.simple_write(outputdir + '/index.shtml', ix_template.process(ns_list));



